; include \masm32\include\masm32rt.inc
include \masm32\MasmBasic\MasmBasic.inc 
UseM32 = 1

MbGCL	PROTO

NoCL$ MACRO arg
  push arg
  call MbGCL
  EXITM <( EaX)>
ENDM

 printit MACRO
 		push eax
 		push edx
		print "arg #"
		print str$(ebx), " = ["
		pop edx
		pop eax
		.if eax
			.if eax
				print eax, "]", 13, 10
			.endif
		.else
			print "no such arg]", 13, 10
		.endif
		inc ebx
ENDM

.data?
buffer		db MAX_PATH dup(?)

.code
start:
	Let esi="These are the args:"+CrLf$+"#1="+CL$(1)+CrLf$+"#2="+CL$(2)+CrLf$+"#3="+CL$(3)+CrLf$+"#4="+CL$(4)+CrLf$+"#5="+CL$(5)+CrLf$+CrLf$
	print esi
	Clr$ esi
	if 1
	.if CL$(3)
		Print "[", eax, "] is a valid arg 3", 13, 10
	.else
		print "no arg 3 found", 13, 10
	.endif
	.if CL$(6)
		Print "[", eax, "] is a valid arg 6", 13, 10, 10
	.else
		print "no arg 6 found", 13, 10, 10
	.endif
	; MsgBox 0, esi, "Hi", MB_OK
	endif
	xor ebx, ebx	; get all args including path name
	Print CrLf$, "Results for MasmBasic CL$(n):", CrLf$
	.Repeat
		void CL$(ebx)
		push eax
		printit
		pop eax
	.Until !eax
	mov eax, MbGCL_endp
	sub eax, MbGCL
	print str$(eax), " bytes proc size", 13, 10, 10

	if 0
	xor ebx, ebx	; get all args including path name
	.Repeat
		Print Str$("arg #%i = [", ebx), CL$(ebx), "]", CrLf$
		inc ebx
	.Until ebx==7
	mov eax, MbGCL_endp
	sub eax, MbGCL
	print str$(eax), " bytes proc size", 13, 10, 10
	endif

if UseM32
	xor ebx, ebx	; get all args including path name
	Print CrLf$, "Results for Masm32 GetCL:", CrLf$
	.Repeat
		invoke GetCL, ebx, offset buffer
		.Break .if eax!=1
		print "arg #"
		print str$(ebx), " = ["
		print offset buffer, "]", 13, 10
		inc ebx
	.Until 0
	mov eax, GetCL_endp
	sub eax, GetCL
	print str$(eax), " bytes", 13, 10, 10
endif
	inkey "BYE"
	Exit debug

MbGCL proc uses esi edi ecx ; numb ;, buf
  call GetCommandLine	; "get cl.exe" arg1 'arg 2' "arg 3"
  xchg esi, eax
  call MbBufferGet
  push eax
  .Repeat
	mov edi, [esp]	; fresh start for each loop
	mov al, 32	; default: blank
	.Repeat
		xchg eax, edx
		lodsb
	.Until al>39
	.Repeat
		stosb
		lodsb
	.Until !al || al==dl
	dec dword ptr [esp+8+3*4]
	.Break .if Sign?
  .Until !al
  push 0
  pop esi
  mov [edi], esi
  .if Sign?			; correct arg found
	.if al==dl || dl==32
		.if dl
			mov esi, [esp]
; 			OPT_Run	"Get CL.exe" 'This is arg1' "arg 2" 'ARG 3 has "quotes" - OK?' "isn'it great?"
; 			OxPT_Run "get cl.exe" arg1 "second arg"   'third arg' fourth_arg
;			OxPT_Run	LaunchTest.exe
		.endif
	.endif
  .endif
  .if !esi
	xchg esi, [esp]	; zero for pop edx - slow but this is a rare case
	mov edi, esi
	mov al, "?"	; Let cannot test for valid args
	stosb	; +1, len=1
  .endif
  push 1			; flag increase slot
  push edi			; end address
  call MbBufferFix	; sets eax as retval and registers slot [url=+9]?[/url]
  pop eax
  ret
MbGCL endp
MbGCL_endp:

if UseM32
GetCL proc ArgNum:DWORD, ItemBuffer:DWORD

  ; -------------------------------------------------
  ; arguments returned in "ItemBuffer"
  ;
  ; arg 0 = program name
  ; arg 1 = 1st arg
  ; arg 2 = 2nd arg etc....
  ; -------------------------------------------------
  ; Return values in eax
  ;
  ; 1 = successful operation
  ; 2 = no argument exists at specified arg number
  ; 3 = non matching quotation marks
  ; 4 = empty quotation marks
  ; -------------------------------------------------

    LOCAL lpCmdLine      :DWORD
    LOCAL cmdBuffer[192] :BYTE
    LOCAL tmpBuffer[192] :BYTE

    push esi
    push edi

    invoke GetCommandLine
    mov lpCmdLine, eax        ; address command line

  ; -------------------------------------------------
  ; count quotation marks to see if pairs are matched
  ; -------------------------------------------------
    xor ecx, ecx            ; zero ecx & use as counter
    mov esi, lpCmdLine
    
    @@:
      lodsb
      cmp al, 0
      je @F
      cmp al, 34            ; [ " ] character
      jne @B
      inc ecx               ; increment counter
      jmp @B
    @@:

    push ecx                ; save count

    shr ecx, 1              ; integer divide ecx by 2
    shl ecx, 1              ; multiply ecx by 2 to get dividend

    pop eax                 ; put count in eax
    cmp eax, ecx            ; check if they are the same
    je @F
      pop edi
      pop esi
      mov eax, 3            ; return 3 in eax = non matching quotation marks
      ret
    @@:

  ; ------------------------
  ; replace tabs with spaces
  ; ------------------------
    mov esi, lpCmdLine
    lea edi, cmdBuffer

    @@:
      lodsb
      cmp al, 0
      je rtOut
      cmp al, 9     ; tab
      jne rtIn
      mov al, 32
    rtIn:
      stosb
      jmp @B
    rtOut:
      stosb         ; write last byte

  ; -----------------------------------------------------------
  ; substitute spaces in quoted text with replacement character
  ; -----------------------------------------------------------
    lea eax, cmdBuffer
    mov esi, eax
    mov edi, eax

    subSt:
      lodsb
      cmp al, 0
      jne @F
      jmp subOut
    @@:
      cmp al, 34
      jne subNxt
      stosb
      jmp subSl     ; goto subloop
    subNxt:
      stosb
      jmp subSt

    subSl:
      lodsb
      cmp al, 32    ; space
      jne @F
        mov al, 254 ; substitute character
      @@:
      cmp al, 34
      jne @F
        stosb
        jmp subSt
      @@:
      stosb
      jmp subSl

    subOut:
      stosb         ; write last byte

  ; ----------------------------------------------------
  ; the following code determines the correct arg number
  ; and writes the arg into the destination buffer
  ; ----------------------------------------------------
    lea eax, cmdBuffer
    mov esi, eax
    lea edi, tmpBuffer

    mov ecx, 0          ; use ecx as counter

  ; ---------------------------
  ; strip leading spaces if any
  ; ---------------------------
    @@:
      lodsb
      cmp al, 32
      je @B

    l2St:
      cmp ecx, ArgNum     ; the number of the required cmdline arg
      je clSubLp2
      lodsb
      cmp al, 0
      je cl2Out
      cmp al, 32
      jne cl2Ovr           ; if not space

    @@:
      lodsb
      cmp al, 32          ; catch consecutive spaces
      je @B

      inc ecx             ; increment arg count
      cmp al, 0
      je cl2Out

    cl2Ovr:
      jmp l2St

    clSubLp2:
      stosb
    @@:
      lodsb
      cmp al, 32
      je cl2Out
      cmp al, 0
      je cl2Out
      stosb
      jmp @B

    cl2Out:
      mov al, 0
      stosb

  ; ------------------------------
  ; exit if arg number not reached
  ; ------------------------------
    .if ecx < ArgNum
      mov edi, ItemBuffer
      mov al, 0
      stosb
      mov eax, 2  ; return value of 2 means arg did not exist
      pop edi
      pop esi
      ret
    .endif

  ; -------------------------------------------------------------
  ; remove quotation marks and replace the substitution character
  ; -------------------------------------------------------------
    lea eax, tmpBuffer
    mov esi, eax
    mov edi, ItemBuffer

    rqStart:
      lodsb
      cmp al, 0
      je rqOut
      cmp al, 34    ; dont write [ " ] mark
      je rqStart
      cmp al, 254
      jne @F
      mov al, 32    ; substitute space
    @@:
      stosb
      jmp rqStart

  rqOut:
      stosb         ; write zero terminator

  ; ------------------
  ; handle empty quote
  ; ------------------
    mov esi, ItemBuffer
    lodsb
    cmp al, 0
    jne @F
    pop edi
    pop esi
    mov eax, 4  ; return value for empty quote
    ret
  @@:

    mov eax, 1  ; return value success

    pop edi
    pop esi

    ret

GetCL endp
GetCL_endp:
endif

end start
OPT_Olly 2
OPT_Arg1	arg1
OPT_Arg2	'This is arg2'
OPT_Arg3	arg3
OPT_Out	"Get CL.exe"
OPT_Tmp2Asm	1
OPT_Wait	0
